<!-- manual page source format generated by PolyglotMan v3.0.7, -->
<!-- available via anonymous ftp from ftp.cs.berkeley.edu:/ucb/people/phelps/tcltk/rman.tar.Z -->

<HTML>
<HEAD>
<TITLE>Man page for sf2c.1</TITLE>
</HEAD>
<BODY bgcolor=white>
<A HREF="#toc">Table of Contents</A><P>

<H2><A NAME="sect0" HREF="#toc0">Name</A></H2>

<P>
sf2c - first pass of the SUIF Fortran 77 front end

<H2><A NAME="sect1" HREF="#toc1"><B>Synopsis</B></A></H2>

<P>
<B>sf2c</B> [ <I>options</I> ] <I>infile</I>

<H2><A NAME="sect2" HREF="#toc2"><B>Description</B></A></H2>

<P>
The <I>sf2c</I> program forms the first part of the SUIF Fortran
77 front end. It is typically run automatically by <I>scc,</I>
not directly by the user. The output of <I>sf2c</I> should be
run through <I>cpp</I> (the usual C pre-processor, not a part of
SUIF) <I>snoot,</I> <I>fixfortran,</I> and the <I>porky</I> <I>-defaults</I> passes,
in that order, to complete the SUIF Fortran front end.
<P>
The <I>sf2c</I> pass converts Fortran code into a special kind of
C code. The C code is legal and has the same semantics as
the Fortran program, but it also has special Fortran-specific
information encoded in things like assignments to
dummy variables. The most important information this
encodes is the original array type and bound information,
including symbolic bounds.
<P>
This special C program is passed through <I>cpp</I> and then
<I>snoot,</I> the regular ANSI C front end, to translate it into
SUIF code. Then fixfortran extracts the Fortran information
that had been encoded in C, restoring array types,
call-by-reference and common-block variables, and more,
when possible. Note that fixfortran is tightly coupled
with sf2c and expects its input to be in exactly the form
sf2c put it in. Other Fortran to C converters will not
work. It is vital that no changes are made to the C code
before <I>cpp</I> and <I>snoot</I> or to the SUIF code coming out of
snoot before it gets to fixfortran. If any changes are
made, fixfortran will become confused and probably die
with some error message, but it is possible it will produce
incorrect code in that case.
<P>
Our <I>sf2c</I> pass is based largely on a version of the Bell
Labs <I>f2c</I> Fortran-to-C converter. Most of the original <I>f2c</I>
options and features are available in <I>sf2c.</I> The major
changes we've made have been aimed at getting more highlevel
Fortran information encoded in the C output. There
are some strange contortions we put <I>sf2c</I> and fixfortran
through to preserve this information given the structure
of the old <I>f2c.</I> It is strongly recommended that the output
of <I>sf2c</I> never be used directly; the entire front end
of <I>sf2c-cpp-snoot-fixfortran-porky</I> should be treated as a
black box. There are a few command line flags to sf2c
that might be of general interest, but the internals of
the front end are not.
<P>
The <I>sf2c</I> pass takes arguments that end with <I>.f</I> or <I>.F</I> as
Fortran 77 source programs. If no output file is specified
(the <B>-o</B> option), the output (the special C file) is
given the same name but put in the current directory with
an extension of <I>.c.</I> If no arguments are given, then <I>sf2c</I>
reads Fortran from standard input and writes the special C
file to standard output.
<P>
The resulting C code needs to include the <I>sf2c.h</I> header
file, but this is normally taken care of automatically by
<I>scc.</I>    The code must eventually be linked with the
libraries <I>libF77</I> (or its variant, <I>libF77</I><B>_</B><I>doall,</I> in the
case of parallelized code) and <I>libI77,</I> which are included
in the SUIF distribution. This, too, is normally handled
automatically when you use scc to link.

<H2><A NAME="sect3" HREF="#toc3"><B>Options</B> <B>Added</B> <B>for</B> <B>Suif</B></A></H2>


<DL>

<DT><B>-g</B> </DT></DT>
<DD>    Insert C ``#line'' directives to indicate the line
numbers in the original Fortran source. That way
the eventual SUIF file's line annotations will
correctly refer to line numbers in the Fortran
source, not an intermediate Fortran file.
</DD>
</DL>
<P>
Unfortunately, <I>f2c</I> was not set up to keep careful
track of line numbers, so the result is line numbers
that are often off by one in some parts of the
program. They are close enough to be quite useful,
though.
<P>
Note that this option replaces the <B>-g</B> flag in <I>f2c.</I>
The old version of this flag printed the line numbers
in comments, not ``#line'' directives.

<DL>

<DT><B>-o</B> <I>filename</I></DT></DT>
<DD>
Use the given <I>filename</I> as the output file, instead
of trying to figure out an output file based on the
input file name.
</DD>

<DT><B>-pp</B> </DT></DT>
<DD>   Put each array reference on a separate line. Line
breaks are introduced after each array reference if
this option is used. Then if the <B>-g</B> option is not
used, array refernce instructions can be uniquely
identified by their line numbers.
</DD>

<DT><B>-lab</B> </DT></DT>
<DD>Put a semicolon after each label. Why this might
be useful is unclear.
</DD>

<DT><B>-version</B></DT></DT>
<DD>
Print version information to stderr and exit immediately.
This is consistent with the <B>-version</B> flag
for most other SUIF passes that is implemented in
the main SUIF library.
</DD>

<DT><B>-quiet</B> Do </DT></DT>
<DD>not print verbose commentary while compiling.
Without this flag, <I>sf2c</I> prints out the names of
procedures as they are encountered, among other
things.
</DD>
</DL>

<H2><A NAME="sect4" HREF="#toc4"><B>OPTIONS</B> <B>IDENTICAL</B> <B>TO</B> <B>f77</B> <B>AND</B> <B>f2c</B></A></H2>


<DL>

<DT><B>-C</B> </DT></DT>
<DD>    Compile code to check that subscripts are within
declared array bounds.
</DD>

<DT><B>-I2</B> </DT></DT>
<DD>   Render INTEGER and LOGICAL as short, INTEGER*4 as
long int. Assume the default <I>libF77</I> and <I>libI77</I>:
allow only INTEGER*4 (and no LOGICAL) variables in
INQUIREs. This flag is incompatible with the <I>-I4</I>
flag.
</DD>

<DT><B>-onetrip</B></DT></DT>
<DD>
The semantics of a DO loop are changed so that
their bodies are performed at least once if
reached. (Fortran 77 DO loops are not performed at
all if the upper limit is smaller than the lower
limit.)
</DD>

<DT><B>-U</B> </DT></DT>
<DD>    Honor the case of variables and external names.
Fortran keywords must be in lower case.
</DD>

<DT><B>-u</B> </DT></DT>
<DD>    Make the default type of a variable `undefined'
rather than using the default Fortran rules.
</DD>

<DT><B>-w</B></DT></DT>
<DD>
<B>-w66</B> Suppress warning messages. The <B>-w</B> form supresses
all warning messages, the <B>-w66,</B> form supresses only
Fortran 66 compatibility warnings.
</DD>
</DL>

<H2><A NAME="sect5" HREF="#toc5"><B>OPTIONS</B> <B>RETAINED</B> <B>FROM</B> <B>f2c</B></A></H2>


<DL>

<DT><B>-A</B> </DT></DT>
<DD>    Use ANSI C constructs. The default is old-style
(pre-ANSI) C. SUIF note: this option is irrelevant
as far as SUIF is concerned because the old-style C
used is a common subset of old C and ANSI C. The
<I>snoot</I> pass is fine with or without this option, as
it understands the complete ANSI C language.
</DD>

<DT><B>-a</B> </DT></DT>
<DD>    Give local variables automatic (rather than static)
storage unless they appear in a DATA, EQUIVALENCE,
or SAVE statement. SUIF note: for SUIF it's usually
better to use this option because it's easier
to analyze automatic variables. But SUIF will
still be correct whether or not this flag is set.
</DD>

<DT><B>-c</B> </DT></DT>
<DD>    Insert comments showing the original Fortran
source. SUIF note: if this option is used along
with the appropriate <I>cpp</I> and <I>snoot</I> options, comments
can be retained all through the SUIF code in
the form of annotations on mark instructions.
</DD>

<DT><B>-E</B> </DT></DT>
<DD>    Declare uninitialized struct created for COMMON to
be Extern (which <I>sf2c.h</I> CW#defines to be extern if
it is otherwise undefined).
</DD>

<DT><B>-ec</B></DT></DT>
<DD>
<B>-e1c</B> These options are meaningless for SUIF. They cause
<B>sf2c</B> to emit a separate file for each uninitialized
COMMON; e.g. COMMON /ABC/ yields abc_com.c, which
defines abc_. If the option is <B>-e1c,</B> then bundle
the separate files that would result from <B>-ec</B> into
the output file, along with comments giving a <I>sed</I>
<I>(1)</I> script that separates the output file into the
files that <B>-ec</B> would give.
</DD>

<DT><B>-ext</B> </DT></DT>
<DD>Complain about f77 extensions.
</DD>

<DT><B>-i2</B> </DT></DT>
<DD>   Do something similar to what is done by <B>-I2,</B> but
assume a modified <I>libF77</I> and <I>libI77</I> (compiled with
-Df2c_i2), so INTEGER and LOGICAL variables may be
assigned in INQUIREs. This is incompatible with
the <I>-I4</I> option.
</DD>

<DT><B>-R</B> </DT></DT>
<DD>    Do not promote REAL functions and operations to
DOUBLE PRECISION (as <I>f77</I> does).
</DD>

<DT><B>-r8</B> </DT></DT>
<DD>   Promote REAL to DOUBLE PRECISION, COMPLEX to DOUBLE
COMPLEX.
</DD>

<DT><B>-T</B><I>dir</I> </DT></DT>
<DD>Put temporary files in directory <I>dir</I> instead of
/tmp, the default. Note that the <I>TMPDIR</I> environment
variable may also be used to choose the directory
to use for temporary files. The <B>-T</B> option
overrides the <I>TMPDIR</I> environment variable if both
are specified.
</DD>

<DT><B>-w8</B> </DT></DT>
<DD>   Do not complain when COMMON or EQUIVALENCE forces
doubles to be word-aligned.
</DD>

<DT><B>-W</B><I>n</I> </DT></DT>
<DD>   Assume <I>n</I> characters/word (default 4) when initializing
numeric variables with character data.
</DD>

<DT><B>-z</B> </DT></DT>
<DD>    Do not implicitly recognize DOUBLE COMPLEX.
</DD>

<DT><B>!I</B> </DT></DT>
<DD>    Disable the included statement.
</DD>
</DL>

<H2><A NAME="sect6" HREF="#toc6"><B>OPTIONS</B> <B>THAT</B> <B>ARE</B> <B>UNDOCUMENTED</B> <B>IN</B> <B>f77</B></A></H2>

<P>
<B>-66</B> Disallow all extensions to Fortran 66.

<DL>

<DT><B>-d</B> </DT></DT>
<DD>    Turn on debugging mode. Some effects of debugging
mode are that temporary intermediate files are not
removed and some verbose information is generated.
</DD>

<DT><B>-1</B> </DT></DT>
<DD>    Undocumented synonym for the <B>-onetrip</B> flag.
</DD>

<DT><B>-I4</B> </DT></DT>
<DD>   Render INTEGER and LOGICAL as `long int'. If this
option is used, neither of the options <B>-I2</B> or <B>-i2</B>
may be used, as they contradict this option.
</DD>

<DT><B>-Is</B> </DT></DT>
<DD>   Use `short int' as the type for array subscripts.
</DD>

<DT><B>-O</B><I>n</I> </DT></DT>
<DD>   Set the maximum number of register variables to
use. For SUIF we ignore whether the variable was
declared ``register'' in C anyway, so this option
is meaningless.
</DD>

<DT><B>-Nq</B><I>n</I></DT></DT>
<DD>
<B>-Nx</B><I>n</I>
<B>-Ns</B><I>n</I>
<B>-Nc</B><I>n</I>
<B>-Nn</B><I>n</I> Set various implementation size limits (internal
table sizes). These flags set, respectively, limits
on the number of equivalences (default 150),
external symbols (default 200), statement labels
(default 801), nesting of loops or if-then-elses
(default 20), and identifier names (default 401).
</DD>

<DT><B>-p</B> </DT></DT>
<DD>    Use #defines within each procedure to make references
to common block variables look to human readers
like local variables. For SUIF this is irrelevant
since the macros will have been expanded by
the C pre-processor before SUIF code is ever produced.
SUIF's Fortran mode allows SUIF programs to
see common block variables as locals.
</DD>

<DT><B>-Fr</B><I>format-string</I></DT></DT>
<DD>
<B>-Fd</B><I>format-string</I>
Use the specified string to format, respectively,
`float' or `double' data written to the output C
file. The defaults are (float)%s (or %sf if
the <B>-A</B> flag is used to specify ANSI-C) for `float'
and %.17g for `double'.
</DD>

<DT><B>-ev</B> </DT></DT>
<DD>   This option might mean to #define things in equivalences
to look like ordinary local variables to
human readers of the C file. If so, it is irrelevant
to SUIF since the C pre-processor substitutes
for the macros before the code is converted to
SUIF.
</DD>
</DL>

<H2><A NAME="sect7" HREF="#toc7"><B>Environment</B> <B>Variables</B></A></H2>

<P>
<B>TMPDIR</B> This variable specifies the directory to use for
temporary files instead of the default /tmp directory.
See also the <B>-T</B> option.

<H2><A NAME="sect8" HREF="#toc8"><B>See</B> <B>Also</B></A></H2>

<P>
<I>scc,</I> <I>snoot,</I> <I>fixfortran,</I> <I>porky,</I> and <I>f77.</I>

<H2><A NAME="sect9" HREF="#toc9"><B>History</B></A></H2>

<P>
The version of <I>f2c</I> upon which <I>sf2c</I> is based calls itself,
VERSION 14 December 1989 7:55:33". It was adapted for an
early version of SUIF by Dror Maydan. Chris Wilson made
more modifications to get the information required by the
current SUIF system.
<P>
Parts of this document were taken from the man page distributed
with <I>f2c.</I>
<P>

<HR><P>
<A NAME="toc"><B>Table of Contents</B></A><P>
<UL>
<LI><A NAME="toc0" HREF="#sect0">Name</A></LI>
<LI><A NAME="toc1" HREF="#sect1">Synopsis</A></LI>
<LI><A NAME="toc2" HREF="#sect2">Description</A></LI>
<LI><A NAME="toc3" HREF="#sect3">Options Added for Suif</A></LI>
<LI><A NAME="toc4" HREF="#sect4">OPTIONS IDENTICAL TO f77 AND f2c</A></LI>
<LI><A NAME="toc5" HREF="#sect5">OPTIONS RETAINED FROM f2c</A></LI>
<LI><A NAME="toc6" HREF="#sect6">OPTIONS THAT ARE UNDOCUMENTED IN f77</A></LI>
<LI><A NAME="toc7" HREF="#sect7">Environment Variables</A></LI>
<LI><A NAME="toc8" HREF="#sect8">See Also</A></LI>
<LI><A NAME="toc9" HREF="#sect9">History</A></LI>
</UL>
</BODY></HTML>
